#!/usr/bin/perl -w
# ./FasIdenDel.pl in.fas

use strict;
use warnings;

my $infile = "$ARGV[0]";

my $name = "";
my $seq = "";
my $whitespace = '';
my $newName = "";
my $xseq = "";
my $yseq = "";

my $num = 0;

my $spnum = 0;
my $SeqLength = 0;
my $LineMilestone = 0;
my $stone = 0;
my $count = 0;

my @inFileCont =  ( );
my @SpListArray = ( );
my @newSpListArray = ( );

my %efas = ( );
my %newfas = ( );

open(INFILE,"$infile");
@inFileCont = <INFILE>;
close INFILE;


# 各ファイルからファスタ形式を取り込んでハッシュに格納する．
foreach my $line (@inFileCont) {
  if ($line =~ /^>/) {
  
    # > 行の数をカウントする．
    $spnum++;

    if ($LineMilestone == 0) {
      chomp($line);
      $name = $line;
      $LineMilestone = 1;      
    } else {
      $name =~ s/>//g;
      push(@SpListArray,$name);
      $efas{$name} = $seq;
      $name = '';
      $seq = '';
      chomp($line);
      $name = $line;    
    }
  } else {
    chomp($line);
    $seq .= $line;
  }
}
$name =~ s/>//g;
push(@SpListArray,$name);
$efas{$name} = $seq;


# 同じ配列の除去
foreach my $xname (@SpListArray){
#   print "stone0>$xname\n$efas{$xname}\n";
    $xseq = $efas{$xname};

  # 最初のデータは newfas に入れる
  if($stone == 0){
    $newfas{$xname} = $xseq;
    push(@newSpListArray,$xname);
    $stone = 1;  

  } else {

    #newfas に同じ配列がいくつあるか調べる
    foreach my $yname (@newSpListArray){
      $yseq = "$newfas{$yname}";
      
      if($xseq eq $yseq){
#        print "$xname eq $yname\n";
        $count++;
      } else {
#       print "$xname ne $yname\n";
        next
      }
    }    

    # newfas に同じ配列がなければ，あたらに加える
    if($count == 0){
      $newfas{$xname} = $xseq;
      push(@newSpListArray,$xname);
    }
    $count = 0;

  }
}


foreach my $pname (@newSpListArray){
  print ">$pname\n$newfas{$pname}\n";
}
